! Copyright 2002 by Dan Pressnell (dan_pressnell@yahoo.com)

!====================================
! cwODBC version 1.9
!====================================

! Changed in version 1.9
!   ---  Added sqlBuilder interface (see note at interface declaration)
!   ---  Fixed bug in GetColumnValue(columnsreturned+1) when using file structure with no fields.
! Changed in version 1.8
!   ---  Added SendQuerySilent method to send query with silent error handling
! Changed in version 1.7
!   ---  Added FillQueueWithResultByName method
!   ---  Queries that fill a queue (and the FillQueue... methods) now leave queue record 1 as the current entry when finished
! Changed in version 1.6
!   ---  Added method to get the database server name (different than prop:dbmsver)
! changed in version 1.5
!   ---  Added the method CreateAccessDatabase() so you can create a new blank Microsoft Access Database
!        file at runtime (subject to change!)
! changed in version 1.3
!   ---  Added SqlQuote and SqlLike as stand-alone procedures
! changed in version 1.2
!   ---  return values added for some procedures
!   ---  new methods added (see interface declaration)
! changed in version 1.1
!   ---  Attempt to fix situation where column count is 0 after first query


! This is freeware.  You are free to make any changes, but if you distribute this package, please distribute
! the original package as supplied by me.  If you think you have some good changes or additions, suggest
! them to me.

!  To use this package:
!
!     (1) put cwodbc.inc and cwodbc.clw in clarion's LIBSRC folder
!     (2) put odbc32.lib and Odbccp32.lib in clarion's LIB folder
!     (3) compile cwsql.prj
!     (4) put the compiled cwsql.dll in clarion's BIN folder, and cwsql.lib in clarion's LIB folder
!     (5) in your apps or projects, put this:
!           in global embeds before includes...
!                   INCLUDE('cwodbc.inc'), once
!           in the project settings, add the library file cwsql.lib

! See the sample code in the Sample1.prj project and source files

! No support is guaranteed, and there will be no templates for this package.  If you have comments or suggestions,
! I prefer that you use the newsgroups devoted to Clarion for Windows, so everybody can benefit, and I won't
! be swamped with private email.

! Be aware that with the release of Clarion 5.6, with ADO, much of this might become outdated technology, although
! I don't think so, because this package is very lean and fast, and I doubt ADO will improve on that.



cwodbc                interface
Release               procedure()
SetDefaultFile        procedure(*file pfile)
SetFile               procedure(*file pFile)
SetTableInfo          procedure(string pTableName, string pColumnName)
SetTableInfoAuto      procedure(*file pDummyFile)
SendQuery             procedure(string pQuery), byte, proc ! returns 0 for success, 1 for error
Next                  procedure(), byte ! returns 0 if okay, 1 if no more records
GetColumnValue        procedure(long pColumn), string
GetColumnName         procedure(long pColumn), string
GetResultColumnCount  procedure(), long
GetColumnValueByName  procedure(string pColumnName), string
FillQueueWithResult   procedure(*queue pQueue)
QueryFromQueue        procedure(*queue pQueue, string pQuery), byte, proc ! returns 0 for success, 1 for error
SqlQuote              procedure(string pStr), string
SqlLike               procedure(string pStr), string
Tables                procedure(*queue pQueue)
Columns               procedure(*queue pQueue, string pTableName)
GetLastErrorString    procedure(), string
GetLastSQL            procedure(), string
! -- following methods added in version 1.2
SetSilentErrors       procedure(byte pSilent) ! 1=don't display errors after query; default is 0  .. this setting is GLOBAL to all objects
GetLastErrorcode      procedure(), long
GetLastFileError      procedure(), string
GetLastFileErrorCode  procedure(), string
GetFileRef            procedure(), *file
! -- following methods added in version 1.5
CreateAccessDatabase  procedure(string pFileName, long pVersion=0), byte
! -- added in version 1.6
GetDBMSName           procedure(), string  ! this is different than the prop:DBMSver in Clarion
! -- added in version 1.7
FillQueueWithResultByName procedure(*queue pQueue)
! -- added in version 1.8
SendQuerySilent       procedure(string pQuery), byte, proc
                      end

cwODBCcolumnqueuetype   queue, type  ! use this queue type with the Columns method
Database      string(100)
Owner         string(100)
Table         string(100)
ColumnName    string(100)
nColumnType   long
ColumnType    string(100)
ColumnSize    long
BufferLength  long
DecimalDigits long
NumPrecRadix  long
Nullable      long
Remarks       string(255)
DefaultValue  string(100)
SqlDataType   long
SqlDateTimeSub  long
CharOctetLength long
OrdinalPosition long
IsNullable      string(10)

            end

cwODBCTableQueueType  queue, type  ! use this queue type with the Tables method
Catalog         string(100)
Owner           string(100)
TableName       string(100)
TableType       string(100)
Remarks         string(255)
                end


! --- note ...  sqlBuilder is a work in progress.  It has not been tested fully, and is subject to change.
sqlBuilder    interface
Release       procedure()
AddTable      procedure(string pTableName) ! can use alias... addtable('customer c')
AddField      procedure(string pExpression, <string pAlias>)
AddAggregate  procedure(string pExpression, <string pAlias>)
AddFunction   procedure(string pExpression, <string pAlias>) ! does NOT get generated into SQL... can be used by GetField later
GetField      procedure(string pAlias), string  ! pAlias is case sensitive.  returns the Expression for the alias.
AddJoin       procedure(string pJoinExpression) ! addjoin('inner join orders on orders.customerid = customers.customerid')
AddWhere      procedure(string pExpression) ! adds to WHERE clause
GroupBy       procedure() ! adds all fields added with Addfield() to GROUP BY
AddOrder      procedure(string pExpression) ! adds to ORDER BY
AddHaving     procedure(string pExpression) ! adds to HAVING
Distinct      procedure() ! adds DISTINCT to SELECT statement generated
Str           procedure(), string ! returns full generated sql statement
ClearAll      procedure()  ! clears entire object, so you can start over and reuse
              end



  map
    module('cwodbc')
      newcwodbc(), *cwodbc  ! create an instance of the cwodbc object (interface) and return a pointer to it
      newsqlbuilder(), *sqlBuilder
      sqlQuote(string pString), string ! construct quoted string for sending as part of sql (Bob's becomes 'Bob''s') (quotes included)
      sqlLike(string pString), string  ! turns SMITH into 'SMITH%' (quotes included)
    end
  end


